import sys
from mashbase import MashBase

class SimpleMash(MashBase):
    """Does a very simple wordmash dictionary lookup without considering the current word"""
    def __init__(self):

        #A dictionary of words to their mashed up version that collides with another word 
        self.wordMash = {
                        "sunday"   : "munday", 
                        "monday"   : "munday",
                        "tuesday"  : "tuersday",
                        "thursday" : "tuersday",
                        "fairy"    : "ferdy",
                        "friday"   : "ferdy",
                        "van"      : "vagn",
                        "wagon"    : "vagn",
                        "white"    : "weight",
                        "eight"    : "weight",
                        "gray"     : "greyn",
                        "green"    : "greyn",
                        "glove"    : "slove",
                        "stove"    : "slove",
                        "teaspoon" : "tspoon",
                        "spoon"    : "tspoon",
                        "car"      : "cair",
                        "chair"    : "cair",
                        "soap"     : "shoap",
                        "ship"     : "shoap",
                        "seven"    : "soven",
                        "oven"     : "soven",
                        "plate"    : "platne",
                        "plane"    : "platne",
                        "four"     : "fourk",
                        "fork"     : "fourk",
                        "tram"     : "traim",
                        "train"    : "traim",
                        "black"    : "blike",
                        "bike"     : "blike",
                        "bowl"     : "bwlue",
                        "blue"     : "bwlue"
            }

    def mash_word(self, word, predictionMatrix):
        """Mashes a word using a lookup table"""
        if word in self.wordMash:
            return self.wordMash[word]
        return word

