#!/usr/bin/python
#Dependencies: sox libsox-fmt-all octave curl
#Additionally, if you're on python2.6: python-argparse python-imaging
import os, argparse
import solver, spectrogram_splitter, contextual_mash, nnsolver

parser = argparse.ArgumentParser(description="Solves a captcha given the challenge token")
parser.add_argument('challenge', type=str, metavar='challenge or sitekey', help='The challenge token from recaptcha to solve (or if -s is given the site key)')
parser.add_argument('-s', required=False, action='store_true', help='If given, download a challenge using the site key and solve the corresponding captcha')

args = parser.parse_args()
masher = contextual_mash.ContextualMash()
splitter = spectrogram_splitter.SpectrogramSplitter()
the_solver = nnsolver.NnSolver()
if args.s:
    captcha_solver = solver.CaptchaSolver([the_solver], splitter, masher = masher, site_key = args.challenge)
else:
    captcha_solver = solver.CaptchaSolver([the_solver], splitter, masher = masher)

if args.s:
    challenge, url = captcha_solver.get_audio_captcha_url()
    print challenge
else:
    url = "http://www.google.com/recaptcha/api/image?c=" + args.challenge

filename = "current" + str(os.getpid())
if not captcha_solver.get_mp3(url, filename):
    print "Could not download mp3 file"
else:
    print captcha_solver.solve(filename)
